<?php
namespace Util\Events\Task;

use Doctrine\Common\EventSubscriber;
use Doctrine\ORM\Event\LifecycleEventArgs;
use Doctrine\ORM\Event\PreUpdateEventArgs;
use Doctrine\ORM\Events;

use \Zeedhi\DevOps\Model\Projectmanagement\EntitiesInterface\Tree\Treeble;

class TreeChildren implements EventSubscriber {

	public function postLoad(LifecycleEventArgs $e) {
		$entity = $e->getEntity();
		if ($entity instanceof Treeble) {
			$entity->setChildrenClosure(function() use ($e, $entity) {
				return $e->getObjectManager()
						 ->getRepository(get_class($entity))
						 ->getChildren($entity->getId());
			});
		}
	}
	/**
	 * Returns an array of events this subscriber wants to listen to.
	 *
	 * @return array
	 */
	public function getSubscribedEvents() {
		return array(
			Events::postLoad
		);
	}
}