<?php
class ConsumerAndProducerTest extends PHPUnit_Framework_TestCase {

    /** @var MyConsumer */
    protected $consumer;
    /** @var MyProducer */
    protected $producer;
    /** @var \Zeedhi\Queue\Connection */
    protected $connection;

    protected function setUp() {
        $this->connection = new \Zeedhi\Queue\Connection("192.168.122.54", "61613", "admin", "password", "mybroker");
        $this->consumer = new MyConsumer($this->connection);
        $this->producer = new MyProducer($this->connection);
    }

    public function testAll() {
        $message = rand();
        $this->producer->send($message);
        try {
            $this->consumer->run();
        } catch (\Exception $e) {
            $this->assertEquals("Pause run!", $e->getMessage());
        }

        $this->assertEquals($message, array_pop($this->consumer->consumedMessages));
    }
}